diff --git a/apt-listbugs b/apt-listbugs
index 58d67cb..b387947 100755
--- a/apt-listbugs
+++ b/apt-listbugs
@@ -289,7 +289,19 @@ when "apt"
   puts if $DEBUG
   puts "Pre-Install-Pkgs hook info:" if $DEBUG
   state=1
-  STDIN.each { |pkg|
+  apt_hook_fd = ENV["AptHookFd"]
+  if apt_hook_fd.nil?
+      $stderr.puts sprintf(_("E: AptHookFd is undefined"))
+      exit(1)
+  end
+  begin
+      apt_hook_stream = IO.open(apt_hook_fd, 'r')
+  rescue Errno::ENOENT
+        $stderr.puts sprintf(_("W: Cannot open file descriptor %s"), apt_hook_fd)
+        exit(1)
+  end
+
+  apt_hook_stream.each { |pkg|
     pkg=pkg.rstrip
     case state
     when 1
@@ -353,6 +365,7 @@ when "apt"
       end
     end
   }
+  apt_hook_stream.close
   puts if $DEBUG
 when "list", "rss"
   ARGV.each { |pkg|
